select
an.numero, pe1.dtpeso as dt_peso_inicio, pe1.peso as peso_inicio , g1.descricao as grupoinicio_periodo, pe2.dtpeso as dt_peso_fim, pe2.peso as peso_fim, (pe2.peso - pe1.peso) as ganho_total_periodo, cast(((pe2.peso - pe1.peso)/(pe2.dtpeso - pe1.dtpeso)) as decimal(15,3)) as ganho_periodo, g2.descricao as grupo_fim_periodo
from animal an join peso pe1 on pe1.cdpeso = (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and
--*****************************************************************************
-- NA LINHA ABAIXO INFORMAR A DATA DO INCIO DO PERODO, NO FORMATO AAAA-MM-DD
--*****************************************************************************
re.dtpeso >='2012-06-22'
order by re.dtpeso asc) join peso pe2 on pe2.cdpeso =(select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and
--*****************************************************************************
-- na linha abaixo informar a data do fim do perodo, no formato aaaa-mm-dd
--*****************************************************************************
re.dtpeso <='2013-09-19'
order by re.dtpeso desc) left join movgrupo ml on ml.cdmovgrupo = (select first 1 re.cdmovgrupo  from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo =  re.cdmovgrupo where rea.cdanimal = an.cdanimal and re.cdtipogrupoanimal = 3
--*****************************************************************************
-- NA LINHA ABAIXO INFORMAR A DATA DO INCIO DO PERODO, NO FORMATO AAAA-MM-DD
--*****************************************************************************
and re.dtmovimentacao <= '2012-06-22'
order by re.dtmovimentacao desc) left join grupoanimal g1 on g1.cdgrupoanimal = ml.cdgrupoanimal left join movgrupo m2 on m2.cdmovgrupo = (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where rea.cdanimal = an.cdanimal and re.cdtipogrupoanimal = 3
--*****************************************************************************
-- NA LINHA ABAIXO INFORMAR A DATA DO FIM DO PERODO, NO FORMATO AAAA-MM-DD
--*****************************************************************************
and re.dtmovimentacao <= '2013-09-19'
order by re.dtmovimentacao desc) left join grupoanimal g2 on g2.cdgrupoanimal = m2.cdgrupoanimal where an.tipoanimal = 'a' and an.animalrebanho = '1' and an.dtbaixa is null and pe1.cdpeso is not null and pe2.cdpeso is not null
-- na linha abaixo informar a data da pesagem final no dia da venda
and an.dtbaixa = '2013-09-19'
order by
an.numordenado
